blob: e7bf38e920070b45cc5bd03c6034af02ef36a60e [file] [log] [blame]
Masahiro Yamadaed16f5a2014-07-30 14:08:13 +09001# ===========================================================================
2# Kernel configuration targets
3# These targets are used from top-level makefile
4
5PHONY += oldconfig xconfig gconfig menuconfig config silentoldconfig update-po-config \
6 localmodconfig localyesconfig
7
8ifdef KBUILD_KCONFIG
9Kconfig := $(KBUILD_KCONFIG)
10else
11Kconfig := Kconfig
12endif
13
14# We need this, in case the user has it in its environment
15unexport CONFIG_
16
17xconfig: $(obj)/qconf
18 $< $(Kconfig)
19
20gconfig: $(obj)/gconf
21 $< $(Kconfig)
22
23menuconfig: $(obj)/mconf
24 $< $(Kconfig)
25
26config: $(obj)/conf
27 $< --oldaskconfig $(Kconfig)
28
29nconfig: $(obj)/nconf
30 $< $(Kconfig)
31
32oldconfig: $(obj)/conf
33 $< --$@ $(Kconfig)
34
35silentoldconfig: $(obj)/conf
36 $(Q)mkdir -p include/config include/generated
37 $< --$@ $(Kconfig)
38
39localyesconfig localmodconfig: $(obj)/streamline_config.pl $(obj)/conf
40 $(Q)mkdir -p include/config include/generated
41 $(Q)perl $< --$@ $(srctree) $(Kconfig) > .tmp.config
42 $(Q)if [ -f .config ]; then \
43 cmp -s .tmp.config .config || \
44 (mv -f .config .config.old.1; \
45 mv -f .tmp.config .config; \
46 $(obj)/conf --silentoldconfig $(Kconfig); \
47 mv -f .config.old.1 .config.old) \
48 else \
49 mv -f .tmp.config .config; \
50 $(obj)/conf --silentoldconfig $(Kconfig); \
51 fi
52 $(Q)rm -f .tmp.config
53
54# Create new linux.pot file
55# Adjust charset to UTF-8 in .po file to accept UTF-8 in Kconfig files
56update-po-config: $(obj)/kxgettext $(obj)/gconf.glade.h
57 $(Q)echo " GEN config.pot"
58 $(Q)xgettext --default-domain=linux \
59 --add-comments --keyword=_ --keyword=N_ \
60 --from-code=UTF-8 \
61 --files-from=$(srctree)/scripts/kconfig/POTFILES.in \
62 --directory=$(srctree) --directory=$(objtree) \
63 --output $(obj)/config.pot
64 $(Q)sed -i s/CHARSET/UTF-8/ $(obj)/config.pot
65 $(Q)(for i in `ls $(srctree)/arch/*/Kconfig \
66 $(srctree)/arch/*/um/Kconfig`; \
67 do \
68 echo " GEN $$i"; \
69 $(obj)/kxgettext $$i \
70 >> $(obj)/config.pot; \
71 done )
72 $(Q)echo " GEN linux.pot"
73 $(Q)msguniq --sort-by-file --to-code=UTF-8 $(obj)/config.pot \
74 --output $(obj)/linux.pot
75 $(Q)rm -f $(obj)/config.pot
76
77PHONY += allnoconfig allyesconfig allmodconfig alldefconfig randconfig
78
79allnoconfig allyesconfig allmodconfig alldefconfig randconfig: $(obj)/conf
80 $< --$@ $(Kconfig)
81
82PHONY += listnewconfig olddefconfig oldnoconfig savedefconfig defconfig
83
84listnewconfig olddefconfig: $(obj)/conf
85 $< --$@ $(Kconfig)
86
87# oldnoconfig is an alias of olddefconfig, because people already are dependent
88# on its behavior(sets new symbols to their default value but not 'n') with the
89# counter-intuitive name.
90oldnoconfig: $(obj)/conf
91 $< --olddefconfig $(Kconfig)
92
93savedefconfig: $(obj)/conf
94 $< --$@=defconfig $(Kconfig)
95
96defconfig: $(obj)/conf
97ifeq ($(KBUILD_DEFCONFIG),)
98 $< --defconfig $(Kconfig)
99else
100 @echo "*** Default configuration is based on '$(KBUILD_DEFCONFIG)'"
101 $(Q)$< --defconfig=arch/$(SRCARCH)/configs/$(KBUILD_DEFCONFIG) $(Kconfig)
102endif
103
104%_defconfig: $(obj)/conf
105 $(Q)$< --defconfig=arch/$(SRCARCH)/configs/$@ $(Kconfig)
106
107# Help text used by make help
108help:
109 @echo ' config - Update current config utilising a line-oriented program'
110 @echo ' nconfig - Update current config utilising a ncurses menu based program'
111 @echo ' menuconfig - Update current config utilising a menu based program'
112 @echo ' xconfig - Update current config utilising a QT based front-end'
113 @echo ' gconfig - Update current config utilising a GTK based front-end'
114 @echo ' oldconfig - Update current config utilising a provided .config as base'
115 @echo ' localmodconfig - Update current config disabling modules not loaded'
116 @echo ' localyesconfig - Update current config converting local mods to core'
117 @echo ' silentoldconfig - Same as oldconfig, but quietly, additionally update deps'
118 @echo ' defconfig - New config with default from ARCH supplied defconfig'
119 @echo ' savedefconfig - Save current config as ./defconfig (minimal config)'
120 @echo ' allnoconfig - New config where all options are answered with no'
121 @echo ' allyesconfig - New config where all options are accepted with yes'
122 @echo ' allmodconfig - New config selecting modules when possible'
123 @echo ' alldefconfig - New config with all symbols set to default'
124 @echo ' randconfig - New config with random answer to all options'
125 @echo ' listnewconfig - List new options'
126 @echo ' olddefconfig - Same as silentoldconfig but sets new symbols to their default value'
127
128# lxdialog stuff
129check-lxdialog := $(srctree)/$(src)/lxdialog/check-lxdialog.sh
130
131# Use recursively expanded variables so we do not call gcc unless
132# we really need to do so. (Do not call gcc as part of make mrproper)
133HOST_EXTRACFLAGS += $(shell $(CONFIG_SHELL) $(check-lxdialog) -ccflags) \
134 -DLOCALE
135
136# ===========================================================================
137# Shared Makefile for the various kconfig executables:
138# conf: Used for defconfig, oldconfig and related targets
139# nconf: Used for the nconfig target.
140# Utilizes ncurses
141# mconf: Used for the menuconfig target
142# Utilizes the lxdialog package
143# qconf: Used for the xconfig target
144# Based on QT which needs to be installed to compile it
145# gconf: Used for the gconfig target
146# Based on GTK which needs to be installed to compile it
147# object files used by all kconfig flavours
148
149lxdialog := lxdialog/checklist.o lxdialog/util.o lxdialog/inputbox.o
150lxdialog += lxdialog/textbox.o lxdialog/yesno.o lxdialog/menubox.o
151
152conf-objs := conf.o zconf.tab.o
153mconf-objs := mconf.o zconf.tab.o $(lxdialog)
154nconf-objs := nconf.o zconf.tab.o nconf.gui.o
155kxgettext-objs := kxgettext.o zconf.tab.o
156qconf-cxxobjs := qconf.o
157qconf-objs := zconf.tab.o
158gconf-objs := gconf.o zconf.tab.o
159
Masahiro Yamada8c4532f2014-10-30 11:06:10 +0900160hostprogs-y := conf nconf mconf kxgettext qconf gconf
Masahiro Yamadaed16f5a2014-07-30 14:08:13 +0900161
162clean-files := qconf.moc .tmp_qtcheck .tmp_gtkcheck
163clean-files += zconf.tab.c zconf.lex.c zconf.hash.c gconf.glade.h
Masahiro Yamadaed16f5a2014-07-30 14:08:13 +0900164clean-files += config.pot linux.pot
165
166# Check that we have the required ncurses stuff installed for lxdialog (menuconfig)
167PHONY += $(obj)/dochecklxdialog
168$(addprefix $(obj)/,$(lxdialog)): $(obj)/dochecklxdialog
169$(obj)/dochecklxdialog:
170 $(Q)$(CONFIG_SHELL) $(check-lxdialog) -check $(HOSTCC) $(HOST_EXTRACFLAGS) $(HOSTLOADLIBES_mconf)
171
172always := dochecklxdialog
173
174# Add environment specific flags
175HOST_EXTRACFLAGS += $(shell $(CONFIG_SHELL) $(srctree)/$(src)/check.sh $(HOSTCC) $(HOSTCFLAGS))
176
177# generated files seem to need this to find local include files
178HOSTCFLAGS_zconf.lex.o := -I$(src)
179HOSTCFLAGS_zconf.tab.o := -I$(src)
180
181LEX_PREFIX_zconf := zconf
182YACC_PREFIX_zconf := zconf
183
184HOSTLOADLIBES_qconf = $(KC_QT_LIBS)
185HOSTCXXFLAGS_qconf.o = $(KC_QT_CFLAGS)
186
187HOSTLOADLIBES_gconf = `pkg-config --libs gtk+-2.0 gmodule-2.0 libglade-2.0`
188HOSTCFLAGS_gconf.o = `pkg-config --cflags gtk+-2.0 gmodule-2.0 libglade-2.0` \
189 -Wno-missing-prototypes
190
191HOSTLOADLIBES_mconf = $(shell $(CONFIG_SHELL) $(check-lxdialog) -ldflags $(HOSTCC))
192
193HOSTLOADLIBES_nconf = $(shell \
194 pkg-config --libs menu panel ncurses 2>/dev/null \
195 || echo "-lmenu -lpanel -lncurses" )
196$(obj)/qconf.o: $(obj)/.tmp_qtcheck
197
Masahiro Yamada8c4532f2014-10-30 11:06:10 +0900198ifeq ($(MAKECMDGOALS),xconfig)
Masahiro Yamadaed16f5a2014-07-30 14:08:13 +0900199$(obj)/.tmp_qtcheck: $(src)/Makefile
200-include $(obj)/.tmp_qtcheck
201
202# QT needs some extra effort...
203$(obj)/.tmp_qtcheck:
204 @set -e; echo " CHECK qt"; dir=""; pkg=""; \
205 if ! pkg-config --exists QtCore 2> /dev/null; then \
206 echo "* Unable to find the QT4 tool qmake. Trying to use QT3"; \
207 pkg-config --exists qt 2> /dev/null && pkg=qt; \
208 pkg-config --exists qt-mt 2> /dev/null && pkg=qt-mt; \
209 if [ -n "$$pkg" ]; then \
210 cflags="\$$(shell pkg-config $$pkg --cflags)"; \
211 libs="\$$(shell pkg-config $$pkg --libs)"; \
212 moc="\$$(shell pkg-config $$pkg --variable=prefix)/bin/moc"; \
213 dir="$$(pkg-config $$pkg --variable=prefix)"; \
214 else \
215 for d in $$QTDIR /usr/share/qt* /usr/lib/qt*; do \
216 if [ -f $$d/include/qconfig.h ]; then dir=$$d; break; fi; \
217 done; \
218 if [ -z "$$dir" ]; then \
219 echo >&2 "*"; \
220 echo >&2 "* Unable to find any QT installation. Please make sure that"; \
221 echo >&2 "* the QT4 or QT3 development package is correctly installed and"; \
222 echo >&2 "* either qmake can be found or install pkg-config or set"; \
223 echo >&2 "* the QTDIR environment variable to the correct location."; \
224 echo >&2 "*"; \
225 false; \
226 fi; \
227 libpath=$$dir/lib; lib=qt; osdir=""; \
228 $(HOSTCXX) -print-multi-os-directory > /dev/null 2>&1 && \
229 osdir=x$$($(HOSTCXX) -print-multi-os-directory); \
230 test -d $$libpath/$$osdir && libpath=$$libpath/$$osdir; \
231 test -f $$libpath/libqt-mt.so && lib=qt-mt; \
232 cflags="-I$$dir/include"; \
233 libs="-L$$libpath -Wl,-rpath,$$libpath -l$$lib"; \
234 moc="$$dir/bin/moc"; \
235 fi; \
236 if [ ! -x $$dir/bin/moc -a -x /usr/bin/moc ]; then \
237 echo "*"; \
238 echo "* Unable to find $$dir/bin/moc, using /usr/bin/moc instead."; \
239 echo "*"; \
240 moc="/usr/bin/moc"; \
241 fi; \
242 else \
243 cflags="\$$(shell pkg-config QtCore QtGui Qt3Support --cflags)"; \
244 libs="\$$(shell pkg-config QtCore QtGui Qt3Support --libs)"; \
245 moc="\$$(shell pkg-config QtCore --variable=moc_location)"; \
246 [ -n "$$moc" ] || moc="\$$(shell pkg-config QtCore --variable=prefix)/bin/moc"; \
247 fi; \
248 echo "KC_QT_CFLAGS=$$cflags" > $@; \
249 echo "KC_QT_LIBS=$$libs" >> $@; \
250 echo "KC_QT_MOC=$$moc" >> $@
251endif
252
253$(obj)/gconf.o: $(obj)/.tmp_gtkcheck
254
Masahiro Yamada8c4532f2014-10-30 11:06:10 +0900255ifeq ($(MAKECMDGOALS),gconfig)
Masahiro Yamadaed16f5a2014-07-30 14:08:13 +0900256-include $(obj)/.tmp_gtkcheck
257
258# GTK needs some extra effort, too...
259$(obj)/.tmp_gtkcheck:
260 @if `pkg-config --exists gtk+-2.0 gmodule-2.0 libglade-2.0`; then \
261 if `pkg-config --atleast-version=2.0.0 gtk+-2.0`; then \
262 touch $@; \
263 else \
264 echo >&2 "*"; \
265 echo >&2 "* GTK+ is present but version >= 2.0.0 is required."; \
266 echo >&2 "*"; \
267 false; \
268 fi \
269 else \
270 echo >&2 "*"; \
271 echo >&2 "* Unable to find the GTK+ installation. Please make sure that"; \
272 echo >&2 "* the GTK+ 2.0 development package is correctly installed..."; \
273 echo >&2 "* You need gtk+-2.0, glib-2.0 and libglade-2.0."; \
274 echo >&2 "*"; \
275 false; \
276 fi
277endif
278
279$(obj)/zconf.tab.o: $(obj)/zconf.lex.c $(obj)/zconf.hash.c
280
281$(obj)/qconf.o: $(obj)/qconf.moc
282
283quiet_cmd_moc = MOC $@
284 cmd_moc = $(KC_QT_MOC) -i $< -o $@
285
286$(obj)/%.moc: $(src)/%.h $(obj)/.tmp_qtcheck
287 $(call cmd,moc)
288
289# Extract gconf menu items for I18N support
290$(obj)/gconf.glade.h: $(obj)/gconf.glade
291 $(Q)intltool-extract --type=gettext/glade --srcdir=$(srctree) \
292 $(obj)/gconf.glade